#ifndef GUIHELPER_ORC
#define GUIHELPER_ORC #1#

opcode makeKeys, iS[], S[]S
    SKeys[], SExtend xin

    iLen = lenarray(SKeys)
    SPlantKeys[] init iLen
    iCount = 0
    while iCount < iLen do
        SPlantKeys[iCount] = sprintf("%s_%s", SKeys[iCount], SExtend)
        iCount += 1
    od

    xout iLen, SPlantKeys
endop

; opcode makePlantKeys, iS[], S[]
;     SKeys[] xin
;
;     iLen = lenarray(SKeys)
;     SPlantKeys[] init iLen
;     iCount = 0
;     while iCount < iLen do
;         SPlantKeys[iCount] = sprintf("%s_i", SKeys[iCount])
;         iCount += 1
;     od
;
;     xout iLen, SPlantKeys
; endop

opcode doPaneSelect, 0, S[]
    SKeys[] xin
    ; SParentKeys[] = makePlantKeys(SKeys)

    iLen, SParentKeys[] makeKeys SKeys, "i"
    iLen, SSelectKeys[] makeKeys SKeys, "sel"

    kC = 0
    while kC < iLen do
        kV, kT cabbageGetValue SSelectKeys[kC]
        if kT == 1 then
        endif

        kC += 1
    od

    ; kCurrent init -1
    ; kIndex, kTrig cabbageChanged SSelectKeys
    ; printks2 "kTrig: %d\n", kTrig
    ; printks2 "kIndex: %d\n", kIndex
    ; if kTrig == 1 && (kCurrent != kIndex) then
    ;     printks("changed... %d %d\n", 0, kIndex, kTrig)
    ;
    ;     kCurrent = kIndex
    ;     printks2 "kCurrent: %d\n", kCurrent
    ;     kCount = 0
    ;     while kCount < iLen do
    ;         cabbageSet k(1), SParentKeys[kCount], "visible", (kIndex == kCount ? 1 : 0)
    ;         kCount += 1
    ;     od
    ; endif

endop

opcode doDronePaneSelect, 0, S[]
    SDroneKeys[] xin

    iLen, SDronePaneKeys[] makeKeys SDroneKeys, "i"
    iLen, SDroneSelectKeys[] makeKeys SDroneKeys, "sel"

    kV1, kT1 cabbageGetValue SDroneSelectKeys[0]
    kV2, kT2 cabbageGetValue SDroneSelectKeys[1]
    kV3, kT3 cabbageGetValue SDroneSelectKeys[2]
    kV4, kT4 cabbageGetValue SDroneSelectKeys[3]

    if (kT1 == 1 || kT2 == 1 || kT3 == 1 || kT4 == 1) then
        ; printks("1: %d %d 2: %d %d 3: %d %d 4: %d %d\n", 0, kT1, kV1, kT2, kV2, kT3, kV3, kT4, kV4)

        cabbageSet k(1), SDronePaneKeys[0], "visible", kV1
        cabbageSet k(1), SDronePaneKeys[1], "visible", kV2
        cabbageSet k(1), SDronePaneKeys[2], "visible", kV3
        cabbageSet k(1), SDronePaneKeys[3], "visible", kV4
    endif
endop

opcode doEnvelopePaneSelect, 0, S[]
    SDroneKeys[] xin

    iLen, SDronePaneKeys[] makeKeys SDroneKeys, "i"
    iLen, SDroneSelectKeys[] makeKeys SDroneKeys, "sel"

    kV1, kT1 cabbageGetValue SDroneSelectKeys[0]
    kV2, kT2 cabbageGetValue SDroneSelectKeys[1]
    kV3, kT3 cabbageGetValue SDroneSelectKeys[2]
    kV4, kT4 cabbageGetValue SDroneSelectKeys[3]
    kV5, kT5 cabbageGetValue SDroneSelectKeys[4]

    if (kT1 == 1 || kT2 == 1 || kT3 == 1 || kT4 == 1 || kT5 == 1) then
        ; printks("1: %d %d 2: %d %d 3: %d %d 4: %d %d\n", 0, kT1, kV1, kT2, kV2, kT3, kV3, kT4, kV4)

        cabbageSet k(1), SDronePaneKeys[0], "visible", kV1
        cabbageSet k(1), SDronePaneKeys[1], "visible", kV2
        cabbageSet k(1), SDronePaneKeys[2], "visible", kV3
        cabbageSet k(1), SDronePaneKeys[3], "visible", kV4
        cabbageSet k(1), SDronePaneKeys[4], "visible", kV5
    endif
endop

opcode doEnvelopeTypePaneSelect, 0, S[]
    SDroneKeys[] xin

    iLen, SDronePaneKeys[] makeKeys SDroneKeys, "i"
    iLen, SDroneSelectKeys[] makeKeys SDroneKeys, "sel"

    kV1, kT1 cabbageGetValue SDroneSelectKeys[0]
    kV2, kT2 cabbageGetValue SDroneSelectKeys[1]
    kV3, kT3 cabbageGetValue SDroneSelectKeys[2]
    kV4, kT4 cabbageGetValue SDroneSelectKeys[3]

    if (kT1 == 1 || kT2 == 1 || kT3 == 1 || kT4 == 1) then
        ; printks("1: %d %d 2: %d %d 3: %d %d 4: %d %d\n", 0, kT1, kV1, kT2, kV2, kT3, kV3, kT4, kV4)

        cabbageSet k(1), SDronePaneKeys[0], "visible", kV1
        cabbageSet k(1), SDronePaneKeys[1], "visible", kV2
        cabbageSet k(1), SDronePaneKeys[2], "visible", kV3
        cabbageSet k(1), SDronePaneKeys[3], "visible", kV4
    endif
endop

instr guihelper
    SDroneKeys[] = fillarray("dr0", "dr1", "dr2", "dr3")
    SEnvelope0Keys[] = fillarray("dr0e0", "dr0e1", "dr0e2", "dr0e3", "dr0e4")
    SEnvelope1Keys[] = fillarray("dr1e0", "dr1e1", "dr1e2", "dr1e3", "dr1e4")
    SEnvelope2Keys[] = fillarray("dr2e0", "dr2e1", "dr2e2", "dr2e3", "dr2e4")
    SEnvelope3Keys[] = fillarray("dr3e0", "dr3e1", "dr3e2", "dr3e3", "dr3e4")

    SEnvelopeType00Keys[] = fillarray("dr0e0con", "dr0e0rnd", "dr0e0trg", "dr0e0lfo")
    SEnvelopeType01Keys[] = fillarray("dr0e1con", "dr0e1rnd", "dr0e1trg", "dr0e1lfo")
    SEnvelopeType02Keys[] = fillarray("dr0e2con", "dr0e2rnd", "dr0e2trg", "dr0e2lfo")
    SEnvelopeType03Keys[] = fillarray("dr0e3con", "dr0e3rnd", "dr0e3trg", "dr0e3lfo")
    SEnvelopeType10Keys[] = fillarray("dr1e0con", "dr1e0rnd", "dr1e0trg", "dr1e0lfo")
    SEnvelopeType11Keys[] = fillarray("dr1e1con", "dr1e1rnd", "dr1e1trg", "dr1e1lfo")
    SEnvelopeType12Keys[] = fillarray("dr1e2con", "dr1e2rnd", "dr1e2trg", "dr1e2lfo")
    SEnvelopeType13Keys[] = fillarray("dr1e3con", "dr1e3rnd", "dr1e3trg", "dr1e3lfo")
    SEnvelopeType20Keys[] = fillarray("dr2e0con", "dr2e0rnd", "dr2e0trg", "dr2e0lfo")
    SEnvelopeType21Keys[] = fillarray("dr2e1con", "dr2e1rnd", "dr2e1trg", "dr2e1lfo")
    SEnvelopeType22Keys[] = fillarray("dr2e2con", "dr2e2rnd", "dr2e2trg", "dr2e2lfo")
    SEnvelopeType23Keys[] = fillarray("dr2e3con", "dr2e3rnd", "dr2e3trg", "dr2e3lfo")
    SEnvelopeType30Keys[] = fillarray("dr3e0con", "dr3e0rnd", "dr3e0trg", "dr3e0lfo")
    SEnvelopeType31Keys[] = fillarray("dr3e1con", "dr3e1rnd", "dr3e1trg", "dr3e1lfo")
    SEnvelopeType32Keys[] = fillarray("dr3e2con", "dr3e2rnd", "dr3e2trg", "dr3e2lfo")
    SEnvelopeType33Keys[] = fillarray("dr3e3con", "dr3e3rnd", "dr3e3trg", "dr3e3lfo")

    doDronePaneSelect(SDroneKeys)

    doEnvelopePaneSelect(SEnvelope0Keys)
    doEnvelopePaneSelect(SEnvelope1Keys)
    doEnvelopePaneSelect(SEnvelope2Keys)
    doEnvelopePaneSelect(SEnvelope3Keys)

    doEnvelopeTypePaneSelect(SEnvelopeType00Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType01Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType02Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType03Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType10Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType11Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType12Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType13Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType20Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType21Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType22Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType23Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType30Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType31Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType32Keys)
    doEnvelopeTypePaneSelect(SEnvelopeType33Keys)
endin

instr show_widget
    SWidget chnget "CURRENT_WIDGET"

    if (changed(SWidget) == 1) then
        SNote cabbageGet SWidget, "_notestr"

        cabbageSet k(1), "widget_key", "text", SWidget
        cabbageSet k(1), "widget_note", "text", SNote
    endif
endin

instr init_gui
    ; cabbageSetValue SChannel, iValue
    cabbageSetValue "dr0_sel", 1

    cabbageSetValue "dr0e0_sel", 1
    cabbageSetValue "dr1e0_sel", 1
    cabbageSetValue "dr2e0_sel", 1
    cabbageSetValue "dr3e0_sel", 1

    cabbageSetValue "dr0e0con_sel", 1
    cabbageSetValue "dr0e1con_sel", 1
    cabbageSetValue "dr0e2con_sel", 1
    cabbageSetValue "dr0e3con_sel", 1
    cabbageSetValue "dr1e0con_sel", 1
    cabbageSetValue "dr1e1con_sel", 1
    cabbageSetValue "dr1e2con_sel", 1
    cabbageSetValue "dr1e3con_sel", 1
    cabbageSetValue "dr2e0con_sel", 1
    cabbageSetValue "dr2e1con_sel", 1
    cabbageSetValue "dr2e2con_sel", 1
    cabbageSetValue "dr2e3con_sel", 1
    cabbageSetValue "dr3e0con_sel", 1
    cabbageSetValue "dr3e1con_sel", 1
    cabbageSetValue "dr3e2con_sel", 1
    cabbageSetValue "dr3e3con_sel", 1
endin

#end /* GUIHELPER_ORC */
